package net.ihe.gazelle.proxy.dao;

import java.util.Date;
import java.util.List;

import javax.persistence.EntityManager;

import net.ihe.gazelle.hql.providers.detached.HibernateActionPerformer;
import net.ihe.gazelle.hql.providers.detached.HibernateFailure;
import net.ihe.gazelle.hql.providers.detached.PerformHibernateAction;
import net.ihe.gazelle.proxy.model.tm.Step;
import net.ihe.gazelle.proxy.model.tm.StepQuery;

public class ProxyDAOTM {

	public static void updateStepDate(Integer testStepId)
			throws HibernateFailure {
		HibernateActionPerformer.performHibernateAction(
				new PerformHibernateAction() {
					@Override
					public Object performAction(EntityManager entityManager,
							Object... context) throws Exception {
						List<Step> steps = getStepsByTMId((Integer) context[0]);
						for (Step step : steps) {
							step.setDate(new Date());
							entityManager.merge(step);
						}
						return null;
					}
				}, testStepId);
	}

	public static List<Step> getStepsByTMId(int testStepId) {
		StepQuery stepQuery = new StepQuery();
		stepQuery.tmId().eq(testStepId);
		return stepQuery.getList();
	}

}
