package net.ihe.gazelle.proxy.admin.gui;

import java.io.Serializable;
import java.util.List;

import javax.persistence.EntityManager;

import net.ihe.gazelle.hql.HQLQueryBuilder;
import net.ihe.gazelle.proxy.admin.model.ApplicationConfiguration;

import org.jboss.seam.Component;
import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;

@Name("applicationManager")
@Scope(ScopeType.PAGE)
public class ApplicationManager implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private ApplicationConfiguration preference = null;

	public List<ApplicationConfiguration> getAllPreferences() {
		HQLQueryBuilder<ApplicationConfiguration> builder = new HQLQueryBuilder<ApplicationConfiguration>(
				(EntityManager) Component.getInstance("entityManager"),
				ApplicationConfiguration.class);
		builder.addOrder("variable", true);
		return builder.getList();
	}

	public void savePreference(ApplicationConfiguration inPreference) {
		EntityManager entityManager = (EntityManager) Component
				.getInstance("entityManager");
		entityManager.merge(inPreference);
		entityManager.flush();
		preference = null;
		// reset preferences with scope application
		ApplicationConfigurationManager.instance()
				.resetApplicationConfiguration();
	}

	public void createNewPreference() {
		preference = new ApplicationConfiguration();
	}

	public void setPreference(ApplicationConfiguration preference) {
		this.preference = preference;
	}

	public ApplicationConfiguration getPreference() {
		return preference;
	}
}
